//*******************************************************
// Demonstrates using mouse events to add or remove nodes
//*******************************************************
import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.shape.*;
import javafx.stage.Stage;
public class Dots extends Application
{
    private Group root;

    public void start(Stage primaryStage)
    {
        root = new Group();
        Scene scene = new Scene(root, 400, 300, Color.LIGHTYELLOW);
        scene.setOnMouseClicked(this::processMouseClick); // adding dots
//      scene.setOnMouseDragged(this::processMouseDrag);  // removing dots
        primaryStage.setTitle("Dots");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    public void processMouseClick(MouseEvent event)
    {
        Circle dot = new Circle(event.getX(),event.getY(),10,Color.RED);
        root.getChildren().add(dot); // add a dot
//      root.getChildren().clear();  // remove all children
//      root.getChildren().add(dot);
    }

    public void processMouseDrag(MouseEvent event)
    {
        Circle t;
        for (int i=0; i<root.getChildren().size(); i++)
        {
            t = (Circle)root.getChildren().get(i);
            if (distance(t.getCenterX(),t.getCenterY(),
                event.getX(),event.getY()) < 10)
                root.getChildren().remove(i);
        }
    }

    private int distance(double x1,double y1,double x2,double y2)
    {
        return (int)Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
    }
}
